<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"] ?: array()) + array("_ef2948c87ef38aab" . "9226e41189b29ca7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX" . "2FjbCBXSEVSRSBvYmplY3RfY2" . "9kZSBlcTpzdHI6Y29kZQ=="), "_84718d82" . "8d2acc3c3" . "66f96b07e" . "841f6a" => base64_decode("YWNsLnNp" . "bXBsZQ=="), "_0877a0b48cf424a0de57a" . "453ce95e30c" => base64_decode("aW50O" . "nVzZX" . "JfaWQ" . "="), "_a7ed4d7408bb99b87a09d89d4" . "212d5de" => base64_decode("c2ltc" . "GxlX2" . "FjbA=" . "="), "_3cda3f34ada928e4aa39d462" . "9c5504aa" => base64_decode("aW50OnJpZ2h0cw" . "=="), "_27de5a45" . "db71bf240" . "58769b61b" . "3975a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG5vdCBzcGVj" . "aWZpZWQ="), "_b06968b9268deaf3b380bd0fe922b4" . "53" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEV" . "SRSBvYmplY3RfY29kZSBlcTpzdHI6Y29kZS" . "BBTkQgdXNlcl9pZD1pbnQ6dWlk"), "_80fc2a45acd01" . "50df87d1fb7289" . "40a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUg" . "b2JqZWN0X2NvZGUgZXE6c3RyOmNvZGUgQU5EIHVzZXJfaWQ9" . "aW50OnVpZA=="), "_dbbe14f56769" . "3a631f8a43b65" . "af917ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmc" . "m9tIGRhdGFiYXNlOiBvYmplY3" . "QgY29kZSBub3Qgc3BlY2lmaWV" . "k"), "_a8b22fedb27a" . "11e07f5bb9a7c" . "73608ea" => base64_decode("c3RyKDEwMCk6b2J" . "qZWN0X2NvZGU="), "_938704c4c0169c3804d4bd6aa" . "9941a76" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9" . "iamVjdCBjb2RlIG5vdCBzcG" . "VjaWZpZWQ="), "_c95cbc316178c97697a403f4d" . "9124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOm" . "NvZGU="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_84718d828d2acc3c366f9" . "6b07e841f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_80fc2a4" . "5acd0150" . "df87d1fb" . "728940a6" . "0"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_a7ed4d7408bb99b87a09d89d4212d5" . "de"], [$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_a8b22fedb27a11e07f5bb9a7c73608e" . "a"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_0877a0b48cf4" . "24a0de57a453c" . "e95e30c"] => $user_id, $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_3cda3f34ada928e4aa39" . "d4629c5504aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_b06968b9268deaf3b380bd0fe922" . "b453"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_938704c4c0169c3804d4bd6aa994" . "1a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_c95cbc316178c97697a403f4d" . "9124106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_27de5a45db71bf24058769" . "b61b3975a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_dbbe14f567693a631f8a43b" . "65af917ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_ef2948c" . "87ef38aa" . "b9226e41" . "189b29ca" . "7"], $acl->GetObjectCode());
    }
}